## runc-stable 1.3.3

=== internal/third_party/selinux/Makefile ===
GO ?= go

all: build build-cross

define go-build
	GOOS=$(1) GOARCH=$(2) $(GO) build ${BUILDFLAGS} ./...
endef

.PHONY: build
build:
	$(call go-build,linux,amd64)

.PHONY: build-cross
build-cross:
	$(call go-build,linux,386)
	$(call go-build,linux,arm)
	$(call go-build,linux,arm64)
	$(call go-build,linux,ppc64le)
	$(call go-build,linux,s390x)
	$(call go-build,linux,mips64le)
	$(call go-build,linux,riscv64)
	$(call go-build,windows,amd64)
	$(call go-build,windows,386)


.PHONY: test
test:
	$(GO) test -timeout 3m ${TESTFLAGS} -v ./...

.PHONY: lint
lint:
	golangci-lint run

.PHONY: vendor
vendor:
	$(GO) mod tidy
	$(GO) mod verify

=== vendor/github.com/cilium/ebpf/Makefile ===
# The development version of clang is distributed as the 'clang' binary,
# while stable/released versions have a version number attached.
# Pin the default clang to a stable version.
CLANG ?= clang-17
STRIP ?= llvm-strip-17
OBJCOPY ?= llvm-objcopy-17
CFLAGS := -O2 -g -Wall -Werror $(CFLAGS)

CI_KERNEL_URL ?= https://github.com/cilium/ci-kernels/raw/master/

# Obtain an absolute path to the directory of the Makefile.
# Assume the Makefile is in the root of the repository.
REPODIR := $(shell dirname $(realpath $(firstword $(MAKEFILE_LIST))))
UIDGID := $(shell stat -c '%u:%g' ${REPODIR})

# Prefer podman if installed, otherwise use docker.
# Note: Setting the var at runtime will always override.
CONTAINER_ENGINE ?= $(if $(shell command -v podman), podman, docker)
CONTAINER_RUN_ARGS ?= $(if $(filter ${CONTAINER_ENGINE}, podman), --log-driver=none, --user "${UIDGID}")

IMAGE := $(shell cat ${REPODIR}/testdata/docker/IMAGE)
VERSION := $(shell cat ${REPODIR}/testdata/docker/VERSION)

TARGETS := \
	testdata/loader-clang-11 \
	testdata/loader-clang-14 \
	testdata/loader-$(CLANG) \
	testdata/manyprogs \
	testdata/btf_map_init \
	testdata/invalid_map \
	testdata/raw_tracepoint \
	testdata/invalid_map_static \
	testdata/invalid_btf_map_init \
	testdata/strings \
	testdata/freplace \
	testdata/fentry_fexit \
	testdata/iproute2_map_compat \
	testdata/map_spin_lock \
	testdata/subprog_reloc \
	testdata/fwd_decl \
	testdata/kconfig \
	testdata/ksym \
	testdata/kfunc \
	testdata/invalid-kfunc \
	testdata/kfunc-kmod \
	testdata/constants \
	testdata/errors \
	testdata/variables \
	btf/testdata/relocs \
	btf/testdata/relocs_read \
	btf/testdata/relocs_read_tgt \
	btf/testdata/relocs_enum \
	btf/testdata/tags \
	cmd/bpf2go/testdata/minimal

.PHONY: all clean container-all container-shell generate

.DEFAULT_TARGET = container-all

# Build all ELF binaries using a containerized LLVM toolchain.
container-all:
	+${CONTAINER_ENGINE} run --rm -ti ${CONTAINER_RUN_ARGS} \
		-v "${REPODIR}":/ebpf -w /ebpf --env MAKEFLAGS \
		--env HOME="/tmp" \
		--env BPF2GO_CC="$(CLANG)" \
		--env BPF2GO_FLAGS="-fdebug-prefix-map=/ebpf=. $(CFLAGS)" \
		"${IMAGE}:${VERSION}" \
		make all

# (debug) Drop the user into a shell inside the container as root.
# Set BPF2GO_ envs to make 'make generate' just work.
container-shell:
	${CONTAINER_ENGINE} run --rm -ti \
		-v "${REPODIR}":/ebpf -w /ebpf \
		--env BPF2GO_CC="$(CLANG)" \
		--env BPF2GO_FLAGS="-fdebug-prefix-map=/ebpf=. $(CFLAGS)" \
		"${IMAGE}:${VERSION}"

clean:
	find "$(CURDIR)" -name "*.elf" -delete
	find "$(CURDIR)" -name "*.o" -delete

format:
	find . -type f -name "*.c" | xargs clang-format -i

all: format $(addsuffix -el.elf,$(TARGETS)) $(addsuffix -eb.elf,$(TARGETS)) generate
	ln -srf testdata/loader-$(CLANG)-el.elf testdata/loader-el.elf
	ln -srf testdata/loader-$(CLANG)-eb.elf testdata/loader-eb.elf

generate:
	go generate -run "internal/cmd/gentypes" ./...
	go generate -skip "internal/cmd/gentypes" ./...

testdata/loader-%-el.elf: testdata/loader.c
	$* $(CFLAGS) -target bpfel -c $< -o $@
	$(STRIP) -g $@

testdata/loader-%-eb.elf: testdata/loader.c
	$* $(CFLAGS) -target bpfeb -c $< -o $@
	$(STRIP) -g $@

%-el.elf: %.c
	$(CLANG) $(CFLAGS) -target bpfel -c $< -o $@
	$(STRIP) -g $@

%-eb.elf : %.c
	$(CLANG) $(CFLAGS) -target bpfeb -c $< -o $@
	$(STRIP) -g $@

.PHONY: update-kernel-deps
update-kernel-deps: export KERNEL_VERSION?=6.8
update-kernel-deps:
	./testdata/sh/update-kernel-deps.sh
	$(MAKE) container-all

## runc-stable 1.3.0

=== debian/changelog ===
runc-stable (1.3.0-0ubuntu1) questing; urgency=medium

  * Fork from runc-app (LP: #2120949)
    - Update package name
    - Add Conflics, Replaces, and Provides relations with runc
    - Update package description

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Tue, 26 Aug 2025 14:48:24 -0300

=== debian/control ===
Source: runc-stable
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper-compat (= 12),
               dh-golang,
               go-md2man,
               golang-1.24-go,
               libapparmor-dev,
               libseccomp-dev,
               pkg-config,
               protobuf-compiler
Standards-Version: 4.6.2
Homepage: https://github.com/opencontainers/runc
Vcs-Git: https://github.com/canonical/runc-stable.git
Vcs-Browser: https://github.com/canonical/runc-stable

Package: runc-stable
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: runc
Replaces: runc
Provides: runc
Built-Using: ${misc:Built-Using}
Description: Open Container Project - runtime
 "runc" is a command line client for running applications packaged according
 to the Open Container Format (OCF) and is a compliant implementation of
 the Open Container Project specification.
 .
 This is the stable version of runc in Ubuntu. This package will only receive
 updates for patch releases and security fixes. If you want to get feature
 updates, use runc instead.

## runc-stable 1.3.3

=== debian/changelog ===
runc-stable (1.3.3-0ubuntu1~25.10.2) questing-security; urgency=medium

  * d/patches: Bug fix when starting containers with mounts that contain "..":
    - d/p/v1.3-0025-openat2-improve-resilience-on-busy-systems.patch:
      openat2: improve resilience on busy systems

 -- Nick Galanis <nick.galanis@canonical.com>  Mon, 03 Nov 2025 22:39:39 +0100

runc-stable (1.3.3-0ubuntu1~25.10.1)  questing-security; urgency=medium

  * New upstream release.
  * SECURITY UPDATE: Escaping a container via masked path abuse 
    - CVE-2025-31133
  * SECURITY UPDATE: Escaping a container due to wrong bind-mounts
    - CVE-2025-52565
  * SECURITY UPDATE: Escaping a container and denial of service
    due to arbitrary writes.
    - CVE-2025-52881

 -- Nick Galanis <nick.galanis@canonical.com>  Thu, 30 Oct 2025 12:06:01 +0000

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DH_GOPKG := github.com/opencontainers/runc
TAGS=apparmor seccomp selinux ambient
VERSION=$(shell dpkg-parsechangelog -SVersion)

# Build with Golang 1.24
export PATH := /usr/lib/go-1.24/bin:$(PATH)

# https://go.dev/blog/go116-module-changes
export GO111MODULE := auto
export GOCACHE := $(CURDIR)/.cache

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=_build

override_dh_auto_configure:
	cd man && ./md2man-all.sh
	dh_auto_configure
	## Remove extra license files:
	$(RM) -v \
            _build/src/$(DH_GOPKG)/vendor/github.com/docker/docker/*/*/LICENSE* \
        ;

override_dh_auto_build:
	dh_auto_build -- -tags "$(TAGS)" -ldflags "-X main.version=$(VERSION)"

override_dh_auto_test:
	DH_GOLANG_EXCLUDES="libcontainer/integration" \
        dh_auto_test -- -tags "$(TAGS)"

override_dh_auto_install:
	dh_auto_install
	# Do not ship the library code
	$(RM) -vrf debian/runc-stable/usr/share/gocode
	# Do not ship example/test utilities (LP: #2076981)
	$(foreach bin, recvtty sd-helper seccompagent, $(RM) -v debian/runc-stable/usr/bin/$(bin))

=== debian/watch ===
version=4

opts=\
repack,\
repacksuffix=+dfsg1,\
uversionmangle=s/-rc/~rc/,\
dversionmangle=s/[~+]dfsg\d*$// \
 https://github.com/opencontainers/runc/releases \
 .*archive/.*v?(\d\.\d\.\d.*)\.tar\.gz

## runc-stable 1.3.4

=== debian/changelog ===
runc-stable (1.3.4-0ubuntu1) resolute; urgency=medium

  * Import Upstream version 1.3.4
  * d/p/improve-resilience-on-busy-system.patch: drop patch applied upstream
  * d/p/lp-2130744.patch: drop patch applied upstream
  * d/copyright: update copyright data

 -- Athos Ribeiro <athos@ubuntu.com>  Mon, 09 Feb 2026 10:47:48 -0300

runc-stable (1.3.3-0ubuntu2) resolute; urgency=medium

   * SECURITY REGRESSION: Wrong default tmpfs permission handling
     (LP: #2130744)
     - d/p/lp-2130744.patch: rootfs: only set mode= for tmpfs
       mount if target already existed

 -- Nick Galanis <nick.galanis@canonical.com>  Wed, 19 Nov 2025 13:00:23 +0000

runc-stable (1.3.3-0ubuntu1) resolute; urgency=medium

  * Import Upstream version 1.3.3
  * d/p/improve-resilience-on-busy-system.patch: fix regression on starting
    containers mounting paths with ".."

 -- Athos Ribeiro <athos@ubuntu.com>  Fri, 14 Nov 2025 11:39:42 -0300
